#include <array>
#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <functional>
#include <iterator> // e.g. ostream_iterator
#include <algorithm> // e.g. unique

using namespace std;


template <typename Iter, typename Str>
void PrintTo(ostream& str, Iter beg, Iter end, Str astr)
{
   str << astr;
   copy(beg, end, ostream_iterator<int>(str, ";"));
}


void PrintBeforeUniqueAfterVector(vector<int>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit vector: before: ");
   auto newEnd = unique(cont.begin(), cont.end());
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}

void PrintBeforeUniqueAfterDeque(deque<int>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit deque: before: ");
   auto newEnd = unique(cont.begin(), cont.end());
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}

void PrintBeforeUniqueAfterArray(array<int, 7>& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit array: before: ");
   auto newEnd = unique(cont.begin(), cont.end());
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}




void aufgabe1()
{
   deque<int> dequeInt = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterDeque(dequeInt);

   array<int,7> arr = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterArray(arr);

   vector<int> vec = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterVector(vec);
}



void demo2_2()
{
   vector<int> cont = { 1, 3, 3, 3, 5, 3, 1 };
   auto newEnd = unique(cont.begin(), cont.end());
   copy(cont.begin(), newEnd, ostream_iterator<int>(cout, ";"));
   cout << endl;
}



void demo1() 
{
   demo2_2();
   deque<int> dequeInt = { 1, 3, 3, 3, 5, 3, 3 };
   PrintBeforeUniqueAfterDeque(dequeInt);

   array<int, 7> arr = { 1, 3, 3, 3, 5, 3, 3 };
   PrintBeforeUniqueAfterArray(arr);

   vector<int> vec = { 1, 3, 3, 3, 5, 3, 1 };
   PrintBeforeUniqueAfterVector(vec);
}



